(function webpackUniversalModuleDefinition(root, factory) {
	if(typeof exports === 'object' && typeof module === 'object')
		module.exports = factory(require("rockplate"));
	else if(typeof define === 'function' && define.amd)
		define(["rockplate"], factory);
	else if(typeof exports === 'object')
		exports["rockplate-codemirror"] = factory(require("rockplate"));
	else
		root["rockplate-codemirror"] = factory(root["rockplate"]);
})(typeof self !== 'undefined' ? self : this, function(__WEBPACK_EXTERNAL_MODULE_rockplate__) {
return /******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};
/******/
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/
/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId]) {
/******/ 			return installedModules[moduleId].exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			i: moduleId,
/******/ 			l: false,
/******/ 			exports: {}
/******/ 		};
/******/
/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/
/******/ 		// Flag the module as loaded
/******/ 		module.l = true;
/******/
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/
/******/
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;
/******/
/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;
/******/
/******/ 	// define getter function for harmony exports
/******/ 	__webpack_require__.d = function(exports, name, getter) {
/******/ 		if(!__webpack_require__.o(exports, name)) {
/******/ 			Object.defineProperty(exports, name, { enumerable: true, get: getter });
/******/ 		}
/******/ 	};
/******/
/******/ 	// define __esModule on exports
/******/ 	__webpack_require__.r = function(exports) {
/******/ 		if(typeof Symbol !== 'undefined' && Symbol.toStringTag) {
/******/ 			Object.defineProperty(exports, Symbol.toStringTag, { value: 'Module' });
/******/ 		}
/******/ 		Object.defineProperty(exports, '__esModule', { value: true });
/******/ 	};
/******/
/******/ 	// create a fake namespace object
/******/ 	// mode & 1: value is a module id, require it
/******/ 	// mode & 2: merge all properties of value into the ns
/******/ 	// mode & 4: return value when already ns object
/******/ 	// mode & 8|1: behave like require
/******/ 	__webpack_require__.t = function(value, mode) {
/******/ 		if(mode & 1) value = __webpack_require__(value);
/******/ 		if(mode & 8) return value;
/******/ 		if((mode & 4) && typeof value === 'object' && value && value.__esModule) return value;
/******/ 		var ns = Object.create(null);
/******/ 		__webpack_require__.r(ns);
/******/ 		Object.defineProperty(ns, 'default', { enumerable: true, value: value });
/******/ 		if(mode & 2 && typeof value != 'string') for(var key in value) __webpack_require__.d(ns, key, function(key) { return value[key]; }.bind(null, key));
/******/ 		return ns;
/******/ 	};
/******/
/******/ 	// getDefaultExport function for compatibility with non-harmony modules
/******/ 	__webpack_require__.n = function(module) {
/******/ 		var getter = module && module.__esModule ?
/******/ 			function getDefault() { return module['default']; } :
/******/ 			function getModuleExports() { return module; };
/******/ 		__webpack_require__.d(getter, 'a', getter);
/******/ 		return getter;
/******/ 	};
/******/
/******/ 	// Object.prototype.hasOwnProperty.call
/******/ 	__webpack_require__.o = function(object, property) { return Object.prototype.hasOwnProperty.call(object, property); };
/******/
/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";
/******/
/******/
/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(__webpack_require__.s = "./src/index.ts");
/******/ })
/************************************************************************/
/******/ ({

/***/ "./src/helper.ts":
/*!***********************!*\
  !*** ./src/helper.ts ***!
  \***********************/
/*! exports provided: default */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
var Helper = /** @class */ (function () {
    function Helper() {
        this.cmInstances = [];
        this.rockplates = [];
    }
    Helper.prototype.setRockplate = function (cm, schema, params, strict, forceUpdate) {
        var rock = {
            cm: cm,
            schema: schema,
            params: params,
            strict: strict,
        };
        var idx = this.cmInstances.indexOf(cm);
        var initial = true;
        if (idx !== -1) {
            this.rockplates[idx] = rock;
            initial = false;
        }
        else {
            this.cmInstances.push(cm);
            this.rockplates.push(rock);
        }
        if (initial || forceUpdate) {
            this.updateRockplate(rock);
        }
    };
    Helper.prototype.getRockplate = function (cm) {
        var idx = this.cmInstances.indexOf(cm);
        if (idx === -1) {
            return;
        }
        return this.rockplates[idx];
    };
    Helper.prototype.updateRockplate = function (rock) {
        var value = rock.cm.getValue();
        var doc = rock.cm.getDoc();
        var lastLine = doc.lastLine();
        var lastChar = doc.getLine(doc.lastLine()).length;
        doc.replaceRange(value || '', {
            line: 0,
            ch: 0,
        }, {
            line: lastLine,
            ch: lastChar,
        });
        rock.cm.setValue(value);
        // doc.clearHistory();
        // rock.cm.clearHistory();
    };
    return Helper;
}());
/* harmony default export */ __webpack_exports__["default"] = (new Helper());


/***/ }),

/***/ "./src/index.ts":
/*!**********************!*\
  !*** ./src/index.ts ***!
  \**********************/
/*! exports provided: setRockplate, getRockplate, register */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "setRockplate", function() { return setRockplate; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "getRockplate", function() { return getRockplate; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "register", function() { return register; });
/* harmony import */ var _helper__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./helper */ "./src/helper.ts");
/* harmony import */ var _rockplate_mode__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./rockplate-mode */ "./src/rockplate-mode.ts");
/* harmony import */ var _rockplate_lint__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ./rockplate-lint */ "./src/rockplate-lint.ts");
/* harmony import */ var _rockplate_fold__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ./rockplate-fold */ "./src/rockplate-fold.ts");




var setRockplate = function (cm, schema, params, strict, forceUpdate) {
    return _helper__WEBPACK_IMPORTED_MODULE_0__["default"].setRockplate(cm, schema, params, strict, forceUpdate);
};
var getRockplate = function (cm) {
    return _helper__WEBPACK_IMPORTED_MODULE_0__["default"].getRockplate(cm);
};
var register = function (CodeMirror) {
    Object(_rockplate_mode__WEBPACK_IMPORTED_MODULE_1__["register"])(CodeMirror);
    Object(_rockplate_lint__WEBPACK_IMPORTED_MODULE_2__["register"])(CodeMirror);
    Object(_rockplate_fold__WEBPACK_IMPORTED_MODULE_3__["register"])(CodeMirror);
};
if (window.CodeMirror) {
    register(window.CodeMirror);
}


/***/ }),

/***/ "./src/rockplate-fold.ts":
/*!*******************************!*\
  !*** ./src/rockplate-fold.ts ***!
  \*******************************/
/*! exports provided: register */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "register", function() { return register; });
/* harmony import */ var rockplate__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! rockplate */ "rockplate");
/* harmony import */ var rockplate__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(rockplate__WEBPACK_IMPORTED_MODULE_0__);

var getLines = function (text) {
    return rockplate__WEBPACK_IMPORTED_MODULE_0__["Utils"].getLines(text);
};
var getPosition = function (text, offset) {
    return rockplate__WEBPACK_IMPORTED_MODULE_0__["Utils"].getPositionAt(text, offset);
};
var register = function (CodeMirror) {
    CodeMirror.registerHelper('fold', 'rockplate', function (cm, start) {
        function getBlockType(lineText) {
            var match = lineText && lineText.match(/^.*?\[(\-\-|if|repeat)/);
            if (match) {
                var result = match[1] === '--' ? 'comment' : match[1];
                return result;
            }
            return false;
        }
        var firstLineText = cm.getLine(start.line);
        var blockType = getBlockType(firstLineText);
        if (!blockType) {
            return undefined;
        }
        var prefix = { comment: '[--', if: '[if ', repeat: '[repeat ' }[blockType];
        var text = cm.getValue();
        var lines = getLines(text);
        var line = lines[start.line];
        if (!line) {
            return undefined;
        }
        var linesBefore = lines.slice(0, start.line);
        var chars = firstLineText.indexOf(prefix) + 1;
        var offset = linesBefore.join('\n').length + chars + 2; // within [xx...
        var builder = new rockplate__WEBPACK_IMPORTED_MODULE_0__["Builder"](text);
        var block = builder.getBlockAt(offset);
        if (!(block instanceof rockplate__WEBPACK_IMPORTED_MODULE_0__["CommentBlock"] || block instanceof rockplate__WEBPACK_IMPORTED_MODULE_0__["IfBlock"] || block instanceof rockplate__WEBPACK_IMPORTED_MODULE_0__["RepeatBlock"])) {
            return undefined;
        }
        var offsetEnd = block.offsetEnd - block.expressionEnd.length;
        var positionEnd = getPosition(text, offsetEnd);
        var lineEnd = positionEnd.line - 1;
        // const endLineText = cm.getLine(lineEnd) || '';
        if (lineEnd - start.line < 1) {
            return undefined;
        }
        var beginColumn = firstLineText.indexOf(block.expression) + block.expression.length;
        var endColumn = positionEnd.column;
        return {
            from: CodeMirror.Pos(start.line, beginColumn),
            to: CodeMirror.Pos(lineEnd, endColumn),
        };
    });
};


/***/ }),

/***/ "./src/rockplate-lint.ts":
/*!*******************************!*\
  !*** ./src/rockplate-lint.ts ***!
  \*******************************/
/*! exports provided: register */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "register", function() { return register; });
/* harmony import */ var rockplate__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! rockplate */ "rockplate");
/* harmony import */ var rockplate__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(rockplate__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _helper__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./helper */ "./src/helper.ts");


var register = function (CodeMirror) {
    CodeMirror.registerHelper('lint', 'rockplate', function (text, options, cm) {
        var found = [];
        var rock = _helper__WEBPACK_IMPORTED_MODULE_1__["default"].getRockplate(cm);
        var linter = new rockplate__WEBPACK_IMPORTED_MODULE_0__["Linter"](text, rock && rock.schema, rock && rock.strict);
        var result = linter.lint(rock ? rock.params : {});
        for (var _i = 0, _a = result.lints; _i < _a.length; _i++) {
            var lint = _a[_i];
            found.push({
                severity: lint.severity,
                from: CodeMirror.Pos(lint.position.begin.line - 1, lint.position.begin.column),
                to: CodeMirror.Pos(lint.position.end.line - 1, lint.position.end.column),
                message: lint.message,
            });
        }
        return found;
    });
};


/***/ }),

/***/ "./src/rockplate-mode.ts":
/*!*******************************!*\
  !*** ./src/rockplate-mode.ts ***!
  \*******************************/
/*! exports provided: register */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "register", function() { return register; });
var register = function (CodeMirror) {
    CodeMirror.defineMode('rockplate:inner', function () {
        var numbers = /^(\d[+\-\*\/])?\d+(\.\d+)?/;
        var keywords = new RegExp('((' + ['end if', 'end repeat', 'if ', 'repeat ', 'else'].join(')|(') + '))\\b');
        var operators = new RegExp('((' + [' are not ', ' are ', ' is not ', ' is '].join(')|(') + '))\\b');
        function tokenBase(stream, state) {
            var ch = stream.peek();
            // Comment
            if (state.incomment) {
                if (stream.skipTo('--]')) {
                    stream.eatWhile('-');
                    stream.eat(']');
                    state.incomment = false; // Clear flag
                }
                else {
                    stream.skipToEnd();
                }
                return 'comment';
                // Tag
            }
            else if (state.intag) {
                // After operator
                if (state.operator) {
                    state.operator = false;
                    if (stream.match(operators)) {
                        return 'atom';
                    }
                    if (stream.match(numbers)) {
                        return 'number';
                    }
                }
                // After sign
                if (state.sign) {
                    state.sign = false;
                    if (stream.match(operators)) {
                        return 'atom';
                    }
                    if (stream.match(numbers)) {
                        return 'number';
                    }
                }
                if (state.instring) {
                    stream.next();
                    return 'string';
                }
                else if (stream.match(']')) {
                    stream.eatWhile(']');
                    state.intag = false;
                    return 'tag';
                }
                else {
                    if (true) {
                        if (stream.match(operators)) {
                            return 'atom';
                        }
                        if (stream.match(keywords)) {
                            return 'keyword';
                        }
                        if (stream.sol()) {
                            stream.next();
                        }
                        stream.next();
                    }
                    else {}
                }
                return 'variable-2';
            }
            else if (stream.eat('[')) {
                if (stream.match('--')) {
                    stream.eatWhile('-');
                    state.incomment = true;
                    return 'comment';
                }
                else {
                    state.intag = true;
                    return 'tag';
                }
            }
            stream.next();
        }
        return {
            startState: function () {
                return {};
            },
            token: function (stream, state) {
                return tokenBase(stream, state);
            },
        };
    });
    CodeMirror.defineMode('rockplate', function (config, parserConfig) {
        var rockplateInner = CodeMirror.getMode(config, 'rockplate:inner');
        // return CodeMirror.overlayMode(CodeMirror.getMode(config, parserConfig.backdrop || "text/html"), rockplateInner); // breaks code folding!
        // if (!parserConfig || !parserConfig.base) return rockplateInner;
        // return (CodeMirror as any).multiplexingMode(CodeMirror.getMode(config, parserConfig.base), {
        //   open: /\[/,
        //   close: /\]/,
        //   mode: rockplateInner,
        //   parseDelimiters: true,
        // });
        return rockplateInner;
    });
    CodeMirror.defineMIME('text/x-rockplate', 'rockplate');
};


/***/ }),

/***/ "rockplate":
/*!****************************!*\
  !*** external "rockplate" ***!
  \****************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = __WEBPACK_EXTERNAL_MODULE_rockplate__;

/***/ })

/******/ });
});
//# sourceMappingURL=rockplate-codemirror.js.map